// Code generated by protoc-gen-go. DO NOT EDIT.
// source: signrpc/signer.proto

/*
Package signrpc is a generated protocol buffer package.

It is generated from these files:
	signrpc/signer.proto

It has these top-level messages:
	KeyLocator
	KeyDescriptor
	TxOut
	SignDescriptor
	SignReq
	SignResp
	InputScript
	InputScriptResp
*/
package signrpc

import proto "github.com/golang/protobuf/proto"
import fmt "fmt"
import math "math"

import (
	context "golang.org/x/net/context"
	grpc "google.golang.org/grpc"
)

// Reference imports to suppress errors if they are not otherwise used.
var _ = proto.Marshal
var _ = fmt.Errorf
var _ = math.Inf

// This is a compile-time assertion to ensure that this generated file
// is compatible with the proto package it is being compiled against.
// A compilation error at this line likely means your copy of the
// proto package needs to be updated.
const _ = proto.ProtoPackageIsVersion2 // please upgrade the proto package

type KeyLocator struct {
	// / The family of key being identified.
	KeyFamily int32 `protobuf:"varint,1,opt,name=key_family,json=keyFamily" json:"key_family,omitempty"`
	// / The precise index of the key being identified.
	KeyIndex int32 `protobuf:"varint,2,opt,name=key_index,json=keyIndex" json:"key_index,omitempty"`
}

func (m *KeyLocator) Reset()                    { *m = KeyLocator{} }
func (m *KeyLocator) String() string            { return proto.CompactTextString(m) }
func (*KeyLocator) ProtoMessage()               {}
func (*KeyLocator) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{0} }

func (m *KeyLocator) GetKeyFamily() int32 {
	if m != nil {
		return m.KeyFamily
	}
	return 0
}

func (m *KeyLocator) GetKeyIndex() int32 {
	if m != nil {
		return m.KeyIndex
	}
	return 0
}

type KeyDescriptor struct {
	// *
	// The raw bytes of the key being identified. Either this or the KeyLocator
	// must be specified.
	RawKeyBytes []byte `protobuf:"bytes,1,opt,name=raw_key_bytes,json=rawKeyBytes,proto3" json:"raw_key_bytes,omitempty"`
	// *
	// The key locator that identifies which key to use for signing. Either this
	// or the raw bytes of the target key must be specified.
	KeyLoc *KeyLocator `protobuf:"bytes,2,opt,name=key_loc,json=keyLoc" json:"key_loc,omitempty"`
}

func (m *KeyDescriptor) Reset()                    { *m = KeyDescriptor{} }
func (m *KeyDescriptor) String() string            { return proto.CompactTextString(m) }
func (*KeyDescriptor) ProtoMessage()               {}
func (*KeyDescriptor) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{1} }

func (m *KeyDescriptor) GetRawKeyBytes() []byte {
	if m != nil {
		return m.RawKeyBytes
	}
	return nil
}

func (m *KeyDescriptor) GetKeyLoc() *KeyLocator {
	if m != nil {
		return m.KeyLoc
	}
	return nil
}

type TxOut struct {
	// / The value of the output being spent.
	Value int64 `protobuf:"varint,1,opt,name=value" json:"value,omitempty"`
	// / The script of the output being spent.
	PkScript []byte `protobuf:"bytes,2,opt,name=pk_script,json=pkScript,proto3" json:"pk_script,omitempty"`
}

func (m *TxOut) Reset()                    { *m = TxOut{} }
func (m *TxOut) String() string            { return proto.CompactTextString(m) }
func (*TxOut) ProtoMessage()               {}
func (*TxOut) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{2} }

func (m *TxOut) GetValue() int64 {
	if m != nil {
		return m.Value
	}
	return 0
}

func (m *TxOut) GetPkScript() []byte {
	if m != nil {
		return m.PkScript
	}
	return nil
}

type SignDescriptor struct {
	// *
	// A descriptor that precisely describes *which* key to use for signing. This
	// may provide the raw public key directly, or require the Signer to re-derive
	// the key according to the populated derivation path.
	KeyDesc *KeyDescriptor `protobuf:"bytes,1,opt,name=key_desc,json=keyDesc" json:"key_desc,omitempty"`
	// *
	// A scalar value that will be added to the private key corresponding to the
	// above public key to obtain the private key to be used to sign this input.
	// This value is typically derived via the following computation:
	//
	// derivedKey = privkey + sha256(perCommitmentPoint || pubKey) mod N
	SingleTweak []byte `protobuf:"bytes,2,opt,name=single_tweak,json=singleTweak,proto3" json:"single_tweak,omitempty"`
	// *
	// A private key that will be used in combination with its corresponding
	// private key to derive the private key that is to be used to sign the target
	// input. Within the Lightning protocol, this value is typically the
	// commitment secret from a previously revoked commitment transaction. This
	// value is in combination with two hash values, and the original private key
	// to derive the private key to be used when signing.
	//
	// k = (privKey*sha256(pubKey || tweakPub) +
	// tweakPriv*sha256(tweakPub || pubKey)) mod N
	DoubleTweak []byte `protobuf:"bytes,3,opt,name=double_tweak,json=doubleTweak,proto3" json:"double_tweak,omitempty"`
	// *
	// The full script required to properly redeem the output.  This field will
	// only be populated if a p2wsh or a p2sh output is being signed.
	WitnessScript []byte `protobuf:"bytes,4,opt,name=witness_script,json=witnessScript,proto3" json:"witness_script,omitempty"`
	// *
	// A description of the output being spent. The value and script MUST be provided.
	Output *TxOut `protobuf:"bytes,5,opt,name=output" json:"output,omitempty"`
	// *
	// The target sighash type that should be used when generating the final
	// sighash, and signature.
	Sighash uint32 `protobuf:"varint,7,opt,name=sighash" json:"sighash,omitempty"`
	// *
	// The target input within the transaction that should be signed.
	InputIndex int32 `protobuf:"varint,8,opt,name=input_index,json=inputIndex" json:"input_index,omitempty"`
}

func (m *SignDescriptor) Reset()                    { *m = SignDescriptor{} }
func (m *SignDescriptor) String() string            { return proto.CompactTextString(m) }
func (*SignDescriptor) ProtoMessage()               {}
func (*SignDescriptor) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{3} }

func (m *SignDescriptor) GetKeyDesc() *KeyDescriptor {
	if m != nil {
		return m.KeyDesc
	}
	return nil
}

func (m *SignDescriptor) GetSingleTweak() []byte {
	if m != nil {
		return m.SingleTweak
	}
	return nil
}

func (m *SignDescriptor) GetDoubleTweak() []byte {
	if m != nil {
		return m.DoubleTweak
	}
	return nil
}

func (m *SignDescriptor) GetWitnessScript() []byte {
	if m != nil {
		return m.WitnessScript
	}
	return nil
}

func (m *SignDescriptor) GetOutput() *TxOut {
	if m != nil {
		return m.Output
	}
	return nil
}

func (m *SignDescriptor) GetSighash() uint32 {
	if m != nil {
		return m.Sighash
	}
	return 0
}

func (m *SignDescriptor) GetInputIndex() int32 {
	if m != nil {
		return m.InputIndex
	}
	return 0
}

type SignReq struct {
	// / The raw bytes of the transaction to be signed.
	RawTxBytes []byte `protobuf:"bytes,1,opt,name=raw_tx_bytes,json=rawTxBytes,proto3" json:"raw_tx_bytes,omitempty"`
	// / A set of sign descriptors, for each input to be signed.
	SignDescs []*SignDescriptor `protobuf:"bytes,2,rep,name=sign_descs,json=signDescs" json:"sign_descs,omitempty"`
}

func (m *SignReq) Reset()                    { *m = SignReq{} }
func (m *SignReq) String() string            { return proto.CompactTextString(m) }
func (*SignReq) ProtoMessage()               {}
func (*SignReq) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{4} }

func (m *SignReq) GetRawTxBytes() []byte {
	if m != nil {
		return m.RawTxBytes
	}
	return nil
}

func (m *SignReq) GetSignDescs() []*SignDescriptor {
	if m != nil {
		return m.SignDescs
	}
	return nil
}

type SignResp struct {
	// *
	// A set of signatures realized in a fixed 64-byte format ordered in ascending
	// input order.
	RawSigs [][]byte `protobuf:"bytes,1,rep,name=raw_sigs,json=rawSigs,proto3" json:"raw_sigs,omitempty"`
}

func (m *SignResp) Reset()                    { *m = SignResp{} }
func (m *SignResp) String() string            { return proto.CompactTextString(m) }
func (*SignResp) ProtoMessage()               {}
func (*SignResp) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{5} }

func (m *SignResp) GetRawSigs() [][]byte {
	if m != nil {
		return m.RawSigs
	}
	return nil
}

type InputScript struct {
	// / The serializes witness stack for the specified input.
	Witness [][]byte `protobuf:"bytes,1,rep,name=witness,proto3" json:"witness,omitempty"`
	// **
	// The optional sig script for the specified witness that will only be set if
	// the input specified is a nested p2sh witness program.
	SigScript []byte `protobuf:"bytes,2,opt,name=sig_script,json=sigScript,proto3" json:"sig_script,omitempty"`
}

func (m *InputScript) Reset()                    { *m = InputScript{} }
func (m *InputScript) String() string            { return proto.CompactTextString(m) }
func (*InputScript) ProtoMessage()               {}
func (*InputScript) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{6} }

func (m *InputScript) GetWitness() [][]byte {
	if m != nil {
		return m.Witness
	}
	return nil
}

func (m *InputScript) GetSigScript() []byte {
	if m != nil {
		return m.SigScript
	}
	return nil
}

type InputScriptResp struct {
	// / The set of fully valid input scripts requested.
	InputScripts []*InputScript `protobuf:"bytes,1,rep,name=input_scripts,json=inputScripts" json:"input_scripts,omitempty"`
}

func (m *InputScriptResp) Reset()                    { *m = InputScriptResp{} }
func (m *InputScriptResp) String() string            { return proto.CompactTextString(m) }
func (*InputScriptResp) ProtoMessage()               {}
func (*InputScriptResp) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{7} }

func (m *InputScriptResp) GetInputScripts() []*InputScript {
	if m != nil {
		return m.InputScripts
	}
	return nil
}

func init() {
	proto.RegisterType((*KeyLocator)(nil), "signrpc.KeyLocator")
	proto.RegisterType((*KeyDescriptor)(nil), "signrpc.KeyDescriptor")
	proto.RegisterType((*TxOut)(nil), "signrpc.TxOut")
	proto.RegisterType((*SignDescriptor)(nil), "signrpc.SignDescriptor")
	proto.RegisterType((*SignReq)(nil), "signrpc.SignReq")
	proto.RegisterType((*SignResp)(nil), "signrpc.SignResp")
	proto.RegisterType((*InputScript)(nil), "signrpc.InputScript")
	proto.RegisterType((*InputScriptResp)(nil), "signrpc.InputScriptResp")
}

// Reference imports to suppress errors if they are not otherwise used.
var _ context.Context
var _ grpc.ClientConn

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
const _ = grpc.SupportPackageIsVersion4

// Client API for Signer service

type SignerClient interface {
	// *
	// SignOutputRaw is a method that can be used to generated a signature for a
	// set of inputs/outputs to a transaction. Each request specifies details
	// concerning how the outputs should be signed, which keys they should be
	// signed with, and also any optional tweaks. The return value is a fixed
	// 64-byte signature (the same format as we use on the wire in Lightning).
	//
	// If we are  unable to sign using the specified keys, then an error will be
	// returned.
	SignOutputRaw(ctx context.Context, in *SignReq, opts ...grpc.CallOption) (*SignResp, error)
	// *
	// ComputeInputScript generates a complete InputIndex for the passed
	// transaction with the signature as defined within the passed SignDescriptor.
	// This method should be capable of generating the proper input script for
	// both regular p2wkh output and p2wkh outputs nested within a regular p2sh
	// output.
	//
	// Note that when using this method to sign inputs belonging to the wallet,
	// the only items of the SignDescriptor that need to be populated are pkScript
	// in the TxOut field, the value in that same field, and finally the input
	// index.
	ComputeInputScript(ctx context.Context, in *SignReq, opts ...grpc.CallOption) (*InputScriptResp, error)
}

type signerClient struct {
	cc *grpc.ClientConn
}

func NewSignerClient(cc *grpc.ClientConn) SignerClient {
	return &signerClient{cc}
}

func (c *signerClient) SignOutputRaw(ctx context.Context, in *SignReq, opts ...grpc.CallOption) (*SignResp, error) {
	out := new(SignResp)
	err := grpc.Invoke(ctx, "/signrpc.Signer/SignOutputRaw", in, out, c.cc, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *signerClient) ComputeInputScript(ctx context.Context, in *SignReq, opts ...grpc.CallOption) (*InputScriptResp, error) {
	out := new(InputScriptResp)
	err := grpc.Invoke(ctx, "/signrpc.Signer/ComputeInputScript", in, out, c.cc, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// Server API for Signer service

type SignerServer interface {
	// *
	// SignOutputRaw is a method that can be used to generated a signature for a
	// set of inputs/outputs to a transaction. Each request specifies details
	// concerning how the outputs should be signed, which keys they should be
	// signed with, and also any optional tweaks. The return value is a fixed
	// 64-byte signature (the same format as we use on the wire in Lightning).
	//
	// If we are  unable to sign using the specified keys, then an error will be
	// returned.
	SignOutputRaw(context.Context, *SignReq) (*SignResp, error)
	// *
	// ComputeInputScript generates a complete InputIndex for the passed
	// transaction with the signature as defined within the passed SignDescriptor.
	// This method should be capable of generating the proper input script for
	// both regular p2wkh output and p2wkh outputs nested within a regular p2sh
	// output.
	//
	// Note that when using this method to sign inputs belonging to the wallet,
	// the only items of the SignDescriptor that need to be populated are pkScript
	// in the TxOut field, the value in that same field, and finally the input
	// index.
	ComputeInputScript(context.Context, *SignReq) (*InputScriptResp, error)
}

func RegisterSignerServer(s *grpc.Server, srv SignerServer) {
	s.RegisterService(&_Signer_serviceDesc, srv)
}

func _Signer_SignOutputRaw_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(SignReq)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(SignerServer).SignOutputRaw(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/signrpc.Signer/SignOutputRaw",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(SignerServer).SignOutputRaw(ctx, req.(*SignReq))
	}
	return interceptor(ctx, in, info, handler)
}

func _Signer_ComputeInputScript_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(SignReq)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(SignerServer).ComputeInputScript(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/signrpc.Signer/ComputeInputScript",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(SignerServer).ComputeInputScript(ctx, req.(*SignReq))
	}
	return interceptor(ctx, in, info, handler)
}

var _Signer_serviceDesc = grpc.ServiceDesc{
	ServiceName: "signrpc.Signer",
	HandlerType: (*SignerServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "SignOutputRaw",
			Handler:    _Signer_SignOutputRaw_Handler,
		},
		{
			MethodName: "ComputeInputScript",
			Handler:    _Signer_ComputeInputScript_Handler,
		},
	},
	Streams:  []grpc.StreamDesc{},
	Metadata: "signrpc/signer.proto",
}

func init() { proto.RegisterFile("signrpc/signer.proto", fileDescriptor0) }

var fileDescriptor0 = []byte{
	// 526 bytes of a gzipped FileDescriptorProto
	0x1f, 0x8b, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0xff, 0x6c, 0x53, 0x5f, 0x6f, 0xd3, 0x3e,
	0x14, 0x55, 0xd7, 0x5f, 0x9b, 0xee, 0x26, 0xd9, 0x0f, 0x4c, 0x05, 0x01, 0x84, 0x28, 0x91, 0x86,
	0xfa, 0x80, 0x8a, 0x28, 0x08, 0x09, 0x9e, 0x10, 0xa0, 0x89, 0xa9, 0x93, 0x26, 0xb9, 0x7d, 0x8f,
	0xdc, 0xd4, 0x64, 0x56, 0xba, 0xc4, 0x8b, 0x1d, 0xd2, 0xbc, 0xf1, 0x1d, 0xf8, 0xc2, 0xe8, 0xda,
	0xee, 0x3f, 0xe0, 0xa9, 0x39, 0xc7, 0xf7, 0xde, 0x73, 0x7c, 0x4f, 0x0d, 0x43, 0x25, 0xb2, 0xa2,
	0x92, 0xe9, 0x6b, 0xfc, 0xe5, 0xd5, 0x44, 0x56, 0xa5, 0x2e, 0x89, 0xe7, 0xd8, 0xf8, 0x1b, 0xc0,
	0x8c, 0xb7, 0x57, 0x65, 0xca, 0x74, 0x59, 0x91, 0x67, 0x00, 0x39, 0x6f, 0x93, 0xef, 0xec, 0x56,
	0xac, 0xdb, 0xa8, 0x33, 0xea, 0x8c, 0x7b, 0xf4, 0x34, 0xe7, 0xed, 0x85, 0x21, 0xc8, 0x53, 0x40,
	0x90, 0x88, 0x62, 0xc5, 0x37, 0xd1, 0x89, 0x39, 0x1d, 0xe4, 0xbc, 0xbd, 0x44, 0x1c, 0x33, 0x08,
	0x67, 0xbc, 0xfd, 0xca, 0x55, 0x5a, 0x09, 0x89, 0xc3, 0x62, 0x08, 0x2b, 0xd6, 0x24, 0xd8, 0xb1,
	0x6c, 0x35, 0x57, 0x66, 0x5e, 0x40, 0xfd, 0x8a, 0x35, 0x33, 0xde, 0x7e, 0x46, 0x8a, 0xbc, 0x02,
	0x0f, 0xcf, 0xd7, 0x65, 0x6a, 0xe6, 0xf9, 0xd3, 0x07, 0x13, 0xe7, 0x6c, 0xb2, 0xb7, 0x45, 0xfb,
	0xb9, 0xf9, 0x8e, 0x3f, 0x42, 0x6f, 0xb1, 0xb9, 0xae, 0x35, 0x19, 0x42, 0xef, 0x07, 0x5b, 0xd7,
	0xdc, 0x8c, 0xec, 0x52, 0x0b, 0xd0, 0x9e, 0xcc, 0x13, 0xab, 0x6f, 0xc6, 0x05, 0x74, 0x20, 0xf3,
	0xb9, 0xc1, 0xf1, 0xaf, 0x13, 0x38, 0x9b, 0x8b, 0xac, 0x38, 0x30, 0xf8, 0x06, 0xd0, 0x7d, 0xb2,
	0xe2, 0x2a, 0x35, 0x83, 0xfc, 0xe9, 0xc3, 0x43, 0xf5, 0x7d, 0x25, 0x45, 0x93, 0x08, 0xc9, 0x0b,
	0x08, 0x94, 0x28, 0xb2, 0x35, 0x4f, 0x74, 0xc3, 0x59, 0xee, 0x54, 0x7c, 0xcb, 0x2d, 0x90, 0xc2,
	0x92, 0x55, 0x59, 0x2f, 0x77, 0x25, 0x5d, 0x5b, 0x62, 0x39, 0x5b, 0x72, 0x0e, 0x67, 0x8d, 0xd0,
	0x05, 0x57, 0x6a, 0xeb, 0xf6, 0x3f, 0x53, 0x14, 0x3a, 0xd6, 0x5a, 0x26, 0x2f, 0xa1, 0x5f, 0xd6,
	0x5a, 0xd6, 0x3a, 0xea, 0x19, 0x77, 0x67, 0x3b, 0x77, 0x66, 0x0b, 0xd4, 0x9d, 0x92, 0x08, 0x30,
	0xce, 0x1b, 0xa6, 0x6e, 0x22, 0x6f, 0xd4, 0x19, 0x87, 0x74, 0x0b, 0xc9, 0x73, 0xf0, 0x45, 0x21,
	0x6b, 0xed, 0x22, 0x1b, 0x98, 0xc8, 0xc0, 0x50, 0x36, 0xb4, 0x14, 0x3c, 0x5c, 0x0a, 0xe5, 0x77,
	0x64, 0x04, 0x01, 0xc6, 0xa5, 0x37, 0x47, 0x69, 0x41, 0xc5, 0x9a, 0xc5, 0xc6, 0x86, 0xf5, 0x1e,
	0x00, 0x0d, 0x98, 0x85, 0xa9, 0xe8, 0x64, 0xd4, 0x1d, 0xfb, 0xd3, 0x47, 0x3b, 0x4f, 0xc7, 0xcb,
	0xa5, 0xa7, 0xca, 0x61, 0x15, 0x9f, 0xc3, 0xc0, 0x8a, 0x28, 0x49, 0x1e, 0xc3, 0x00, 0x55, 0x94,
	0xc8, 0x50, 0xa1, 0x3b, 0x0e, 0xa8, 0x57, 0xb1, 0x66, 0x2e, 0x32, 0x15, 0x5f, 0x80, 0x7f, 0x89,
	0xce, 0xdc, 0xed, 0x23, 0xf0, 0xdc, 0x3a, 0xb6, 0x85, 0x0e, 0xe2, 0xbf, 0x54, 0x89, 0xec, 0x38,
	0x68, 0x94, 0x73, 0x49, 0x5f, 0xc1, 0xff, 0x07, 0x73, 0x8c, 0xea, 0x07, 0x08, 0xed, 0x1e, 0x6c,
	0x8f, 0x9d, 0xe8, 0x4f, 0x87, 0x3b, 0xf3, 0x87, 0x0d, 0x81, 0xd8, 0x03, 0x35, 0xfd, 0xd9, 0x81,
	0xfe, 0xdc, 0x3c, 0x1d, 0xf2, 0x0e, 0x42, 0xfc, 0xba, 0x36, 0x5b, 0xa7, 0xac, 0x21, 0xf7, 0x8e,
	0x2e, 0x4f, 0xf9, 0xdd, 0x93, 0xfb, 0x7f, 0x30, 0x4a, 0x92, 0x4f, 0x40, 0xbe, 0x94, 0xb7, 0xb2,
	0xd6, 0xfc, 0xf0, 0x76, 0x7f, 0xb7, 0x46, 0xff, 0x34, 0xc3, 0x95, 0x5c, 0xf6, 0xcd, 0x9b, 0x7d,
	0xfb, 0x3b, 0x00, 0x00, 0xff, 0xff, 0xe8, 0x77, 0xc6, 0x62, 0xcb, 0x03, 0x00, 0x00,
}
